#include "gtest/gtest.h"
#include "WahrFalsch.h"
#include "Fakultaet.h"

TEST(WahrFalschTest, BeideWahrBeideWahr) {
	WahrFalsch obj;
	EXPECT_TRUE(obj.BeideWahr(true,true))<<"Einer Falsch.";
}

TEST(WahrFalschTest, BeideWahrEinerFalsch) {
	WahrFalsch obj;
	EXPECT_FALSE(obj.BeideWahr(false,true));
	EXPECT_FALSE(obj.BeideWahr(true,false));
}

TEST(WahrFalschTest, OderBeideWahr) {
	WahrFalsch obj;
	EXPECT_TRUE(obj.Oder(true,true));
}

TEST(WahrFalschTest, OderEinerFalsch) {
	WahrFalsch obj;
	EXPECT_TRUE(obj.Oder(false,true));
	EXPECT_TRUE(obj.Oder(true,false));
}

TEST(WahrFalschTest, OderBeideFalsch) {
	WahrFalsch obj;
	EXPECT_FALSE(obj.Oder(false,false));
}


class FakultaetTest : public testing::Test {
protected:
	virtual void SetUp() {

	}

	virtual void TearDown() {

	}

	Fakultaet obj;

};

TEST_F(FakultaetTest, Iterativ) {
	EXPECT_ANY_THROW(obj.iterativ(-3));
	EXPECT_NO_THROW(obj.iterativ(3));
	EXPECT_EQ(6,obj.iterativ(3));
}

TEST_F(FakultaetTest, Rekursiv) {
	EXPECT_ANY_THROW(obj.rekursiv(-3));
	EXPECT_NO_THROW(obj.rekursiv(3));
	EXPECT_EQ(6,obj.rekursiv(3));
}


class FakultaetParamsTest : public ::testing::TestWithParam<int> {
protected:
	virtual void SetUp() {

	}

	virtual void TearDown() {

	}

	Fakultaet obj;
};

INSTANTIATE_TEST_CASE_P(TestSequence, FakultaetParamsTest, testing::Range(1,5));

TEST_P(FakultaetParamsTest, TestMitParametern) {
	EXPECT_EQ(obj.iterativ(GetParam()),obj.rekursiv(GetParam()));
}



/* Test mit kombinierten Parametern (Es wird das Kreuzprodukt gebildet)
class FakultaetParamsTest : public ::testing::TestWithParam<std::tr1::tuple<int, int> > {
protected:
	virtual void SetUp() {
		exp = std::tr1::get<0>(GetParam());
		act = std::tr1::get<1>(GetParam());
	}
	Fakultaet obj;
	int exp;
	int act;
};

TEST_P(FakultaetParamsTest, TestMitParametern) {
	EXPECT_EQ(exp,act);
}

INSTANTIATE_TEST_CASE_P(TestSequence, FakultaetParamsTest, testing::Combine(testing::Values(1,2),testing::Range(1,5)));
*/
